﻿deferred class
	STS_COMPLEX

feature
	a, real: like real_anchor
		deferred
		end

	b, imaginary: like real_anchor
		deferred
		end

	zero: like complex_anchor
		deferred
		ensure
			real: Result.a ≍ a.zero
			imaginary: Result.b ≍ b.zero
		end

	one: like complex_anchor
		deferred
		ensure
			real: Result.a ≍ a.one
			imaginary: Result.b ≍ b.zero
		end

	identity alias "+": like Current
		do
			Result := Current
		ensure
			real: Result.a ≍ a
			imaginary: Result.b ≍ b
		end

	complex_anchor: STS_COMPLEX
		do
			Result := Current
		end

	real_anchor: STS_REAL
		do
			Result := a
		end

invariant
	real: real ≍ a
	imaginary: imaginary ≍ b

end
