﻿deferred class
	STS_INTEGER

inherit
	STS_REAL
		rename
			value as real_value,
			equals as real_equals,
			normalized_value as real_normalized_value
		end

feature

	value: INTEGER
		deferred
		end

	zero: like integer_anchor
		deferred
		end

	one: like integer_anchor
		deferred
		end

	equals alias "≍" (i: STS_INTEGER): BOOLEAN
		do
			Result := value = i.value
		ensure
			definition: Result = (value = i.value)
		end

	normalized_value (v: INTEGER): INTEGER
		deferred
		ensure
			stable: normalized_value (Result) = Result
		end

	integer_anchor: STS_INTEGER
		do
			Result := Current
		end

invariant
	value: same_value (value, real_value)

end
